<?php

declare(strict_types=1);

namespace Plugin\cin_autocurrency_5\Migrations;

use JTL\Plugin\Migration;
use JTL\Update\IMigration;

final class Migration20230510121626 extends Migration implements IMigration
{
  public function up(): void
  {
    $this->execute('CREATE TABLE IF NOT EXISTS `xplugin_cin_ip2location_db1_ipv6`(
	`ip_from` DECIMAL(39,0) UNSIGNED NULL DEFAULT NULL,
	`ip_to` DECIMAL(39,0) UNSIGNED NOT NULL,
	`country_code` CHAR(2),
	`country_name` VARCHAR(64),
	INDEX `idx_ip_from` (`ip_from`),
	INDEX `idx_ip_to` (`ip_to`),
  INDEX `idx_ip_country_code_name` (`country_code`, `country_name`),
	INDEX `idx_ip_from_to` (`ip_from`, `ip_to`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci');
  }

  public function down(): void
  {
    if ($this->doDeleteData()) {
      $this->execute('DROP TABLE IF EXISTS xplugin_cin_ip2location_db1_ipv6');
    }
  }
}
