<?php

declare(strict_types=1);

require_once __DIR__.'/../src/warmup.php';

$allRegions = [
  'eu' => [
    'region_code' => 'eu',
    'region_name' => 'EU'
  ],
  'other' => [
    'region_code' => 'other',
    'region_name' => 'Nicht-EU'
  ]
];

$stmt = $P->getPDO()->prepare('SELECT DISTINCT country_code, country_name
  FROM xplugin_cin_ip2location_db1
  WHERE country_code != ?');
$stmt->execute(['-']);
$allCountries = [];
foreach ($stmt->fetchAll() as $country) {
  $allCountries[$country->country_code] = [
    'country_code' => $country->country_code,
    'country_name' => $country->country_name
  ];
}

$allCountries['-'] = [
  'country_code' => '-',
  'country_name' => 'localhost'
];

$stmt = $P->getPDO()->prepare('SELECT * FROM twaehrung ORDER BY cISO');
$stmt->execute();
$allCurrencies = [];
foreach ($stmt->fetchAll() as $currency) {
  $allCurrencies[$currency->kWaehrung] = $currency;
}

$stmt = $P->getPDO()->prepare('SELECT * FROM xplugin_cin_autocurrency_countries_currencies');
$stmt->execute();
$countryAssignments = $stmt->fetchAll(PDO::FETCH_ASSOC);

$stmt = $P->getPDO()->prepare('SELECT * FROM xplugin_cin_autocurrency_regions_currencies');
$stmt->execute();
$regionAssignments = $stmt->fetchAll(PDO::FETCH_ASSOC);

$smarty->assign('allCountries', $allCountries);
$smarty->assign('allCountriesJSON', json_encode($allCountries, \JSON_NUMERIC_CHECK));
$smarty->assign('allCurrencies', $allCurrencies);
$smarty->assign('allCurrenciesJSON', json_encode($allCurrencies, \JSON_NUMERIC_CHECK));
$smarty->assign('allRegions', $allRegions);
$smarty->assign('allRegionsJSON', json_encode($allRegions, \JSON_NUMERIC_CHECK));

$smarty->assign('countryAssignments', $countryAssignments);
$smarty->assign('countryAssignmentsJSON', json_encode($countryAssignments, \JSON_NUMERIC_CHECK));

$smarty->assign('regionAssignments', $regionAssignments);
$smarty->assign('regionAssignmentsJSON', json_encode($regionAssignments, \JSON_NUMERIC_CHECK));

$smarty->assign('xhrURL', $P->getJTlPlugin()->getPaths()->getAdminURL().'xhr.php');
$smarty->assign('assetURL', $P->getJTlPlugin()->getPaths()->getAdminURL());
$smarty->display(__DIR__.'/template/assignments.tpl');
