<?php

declare(strict_types=1);

use JTL\Session\Frontend;

if (isset($_SESSION['cin_autocurrency'])) {
  return;
}

require __DIR__.'/../../src/warmup.php';

$ip = $_SERVER['REMOTE_ADDR'] ?: ($_SERVER['HTTP_X_FORWARDED_FOR'] ?: $_SERVER['HTTP_CLIENT_IP']);

if (mb_strpos(':', $ip)) {
  $stmt = $P->getPDO()->prepare('SELECT country_code
    FROM xplugin_cin_ip2location_db1_ipv6
    WHERE INET6_ATON(?) >= ip_from AND INET6_ATON(?) <= ip_to');
  $stmt->execute([$ip, $ip]);
  $countryCode = $stmt->fetchColumn();
} else {
  $stmt = $P->getPDO()->prepare('SELECT country_code
    FROM xplugin_cin_ip2location_db1
    WHERE INET_ATON(?) >= ip_from AND INET_ATON(?) <= ip_to');
  $stmt->execute([$ip, $ip]);
  $countryCode = $stmt->fetchColumn();
}
if ( ! $countryCode) {
  return;
}

$stmt = $P->getPDO()->prepare('SELECT IF(
	(SELECT COUNT(*) FROM xplugin_cin_autocurrency_countries_currencies xcacc WHERE xcacc.country_code = :ciso1) > 0,
	(SELECT kWaehrung FROM xplugin_cin_autocurrency_countries_currencies WHERE country_code = :ciso2),
	(SELECT kWaehrung FROM xplugin_cin_autocurrency_regions_currencies WHERE region_code = (
		SELECT IF(nEU, "eu", "other") FROM tland WHERE cISO = :ciso3
	))
) kWaehrung');
$stmt->execute([
  'ciso1' => $countryCode,
  'ciso2' => $countryCode,
  'ciso3' => $countryCode
]);

$kWaehrung = (int) $stmt->fetchColumn();
if ( ! $kWaehrung) {
  return;
}

$curr = new JTL\Catalog\Currency($kWaehrung);
Frontend::updateCurrency($curr->getCode());

$_SESSION['cin_autocurrency'] = 'DONE';
