<?php

declare(strict_types=1);

require 'warmup.php';

ini_set('max_execution_time', '0');
if ($output) {
  while (ob_get_level()) {
    ob_end_clean();
  }
  header('Connection: close');
  header('Content-Encoding: none');
  ignore_user_abort(true);
}
if ( ! file_exists(__DIR__.'/datasourceupdated') || time() - filemtime(__DIR__.'/datasourceupdated') > 86400) {
  $dataSource = [
    'v4' => [
      'url'   => 'https://download.ip2location.com/lite/IP2LOCATION-LITE-DB1.CSV.ZIP',
      'zip'   => __DIR__.'/IP2LOCATION-LITE-DB1.CSV.ZIP',
      'file'  => 'IP2LOCATION-LITE-DB1.CSV',
      'table' => 'xplugin_cin_ip2location_db1'
    ],
    'v6' => [
      'url'   => 'https://download.ip2location.com/lite/IP2LOCATION-LITE-DB1.IPV6.CSV.ZIP',
      'zip'   => __DIR__.'/IP2LOCATION-LITE-DB1.IPV6.CSV.ZIP',
      'file'  => 'IP2LOCATION-LITE-DB1.IPV6.CSV',
      'table' => 'xplugin_cin_ip2location_db1_ipv6'
    ]
  ];
  $size = 0;
  foreach ($dataSource as $source) {
    $zip = new ZipArchive();
    if ($output) {
      echo 'Lade Datei '.$source['file'].' herunter';
      @ob_flush();
      flush();
    }
    file_put_contents($source['zip'], fopen($source['url'], 'rb'));
    $zipOpenOk = $zip->open($source['zip']);
    if ($zipOpenOk) {
      $sth          = $P->getPDO()->prepare('INSERT INTO `'.$source['table'].'` (ip_from, ip_to, country_code, country_name) VALUES(?, ?, ?, ?)');
      $zipExtractOk = $zip->extractTo(__DIR__, $source['file']);
      if ($zipExtractOk) {
        $file = new \SplFileObject(__DIR__.'/'.$source['file'], 'r');
        $file->seek(\PHP_INT_MAX);
        $lineCount = $file->key();
        if ($output) {
          echo 'Importiere '.$lineCount.' Zeilen';
          ob_flush();
          flush();
          usleep(500);
          echo 'setup';
          ob_flush();
          flush();
          usleep(500);
        }
        $stream = $zip->getStream($source['file']);
        if ($stream) {
          $P->getPDO()->query('TRUNCATE TABLE `'.$source['table'].'`');
          $currentLine = 0;
          while ( ! feof($stream)) {
            $line    = fgets($stream);
            $columns = str_getcsv($line);
            $sth->execute($columns);
            ++$currentLine;
            if ($output && 0 === $currentLine % 1000) {
              echo round(100 * $currentLine / $lineCount);
              ob_flush();
              flush();
              usleep(100);
            }
          }
          if ($output) {
            usleep(100);
            echo 'teardown';
            @ob_flush();
            flush();
          }
          fclose($stream);
        }
        unlink(__DIR__.'/'.$source['file']);
      }
      $zip->close();
      unlink($source['zip']);
    }
  }
  touch(__DIR__.'/datasourceupdated');
  if ($output) {
    usleep(100);
    echo 'Import abgeschlossen';
    ob_flush();
    flush();
    ob_end_flush();
    flush();
  }
}
